local ADDON, Package = ...

local Module = {}
local Registry = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------
local PROXY = CreateFrame("Frame")

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.enable()
  PROXY:RegisterEvent("PLAYER_REGEN_ENABLED")
  PROXY:RegisterEvent("PLAYER_REGEN_DISABLED")
  PROXY:SetScript("OnEvent", Module.on_event)
end

function Module.disable()
  PROXY:UnregisterEvent("PLAYER_REGEN_ENABLED")
  PROXY:UnregisterEvent("PLAYER_REGEN_DISABLED")
  PROXY:SetScript("OnEvent", nil)
end

function Module.on_event(self, event, ...)
  Registry[event](self, ...)
end

--------------------------------------------------------------------------------
-- Registry
--------------------------------------------------------------------------------
function Registry.PLAYER_REGEN_ENABLED()
  UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE")
end

function Registry.PLAYER_REGEN_DISABLED()
  UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.PreventUIErrorMessageDuringCombat = Module