local ADDON, Package = ...

local Module = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------
local CHAT_FRAMES = {
  ChatFrame1 = ChatFrame1,
  -- ChatFrame2 = ChatFrame2,
  ChatFrame3 = ChatFrame3,
  ChatFrame4 = ChatFrame4,
  ChatFrame5 = ChatFrame5,
  ChatFrame6 = ChatFrame6,
  ChatFrame7 = ChatFrame7,
  ChatFrame8 = ChatFrame8,
  ChatFrame9 = ChatFrame9,
  ChatFrame10 = ChatFrame10
}

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.set_alt_arrow_key_mode(enable)
  local frames = CHAT_FRAMES

  for _, frame in pairs(frames) do
    frame.editBox:SetAltArrowKeyMode(enable)
  end
end

function Module.enable()
  Module.set_alt_arrow_key_mode(false)
end

function Module.disable()
  Module.set_alt_arrow_key_mode(true)
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.UseArrowKeysInChat = Module