local ADDON, Package = ...

local Module = {}
local Registry = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------
local PROXY = CreateFrame("Frame")

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.SetCVar(value)
  SetCVar("cameraDistanceMaxZoomFactor", value)
end

function Module.enable()
  PROXY:RegisterEvent("PLAYER_ENTERING_WORLD")
  PROXY:SetScript("OnEvent", Module.on_event)

  Module.SetCVar("4")
end

function Module.disable()
  PROXY:UnregisterEvent("PLAYER_ENTERING_WORLD")
  PROXY:SetScript("OnEvent", nil)

  Module.SetCVar("2")

  -- CameraZoomOut()
end

function Module.on_event(self, event, ...)
  Registry[event](self, ...)
end

--------------------------------------------------------------------------------
-- Registry
--------------------------------------------------------------------------------
function Registry.PLAYER_ENTERING_WORLD()
  Module.SetCVar("4")
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.UseMaxZoomFactor = Module